﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace V4._1_._2
{
    internal class Fraction
    {
        private int den;
        public Fraction(int num, int den)
        {
            int gcd = gcd (num, den);
            Den = den / gcd;
            Num = num / gcd;
        }

        private int Gcd (int num, int den)
        { 
            int min = Math.Min(Math.Abs(num), Math.Abs(den));
            for (int i = min; i >= 2; i--)
            {
            if (num % i == 0 && den % 1 == 0) return i;
            }
            return 1; 
        }
        public int Num { get; }

        public int Den
        {
            get => den; set
            {
                if (value == 0)
                {
                    //fail fast
                    throw new Exception("NEIN!");
                }
                den = value;
            }
        }

        public override string ToString()
        {
            if (Den == 1)
            {
                return $"{Num}";
            }
            return $"{Num}/{Den}";
        }


        public Fraction Mul(Fraction other) => new Fraction(Num * other.Num, Den * other.Den); // (a/b) * (a2/b2)
        public Fraction Div(Fraction other) => new Fraction(Num * other.Den, Den * other.Num); // (a/b2) * (a2/b) 
        public Fraction Add(Fraction other) => new Fraction(Num * other.Den + Den * other.Num, Den * other.Den); // (a/b) + (a2/b2)
        public Fraction Sub(Fraction other) => new Fraction(Num * other.Den - Den * other.Num, Den * other.Den); // (a/b) - (a2/b2)

        internal static bool TryParse(string text, out Fraction f)
        {
            //"1"
            //"1/2"
            string[] details = text.Split('/');

            f = new Fraction(num,den);
            return true;
        }
    }
}
